<template>
  <b-overlay :show="overlayAccess" rounded="sm" variant="primary" spinner-type="" opacity="0.1" blur="2px">
    <b-overlay :show="overlay" rounded="sm" variant="primary" opacity="0.4" blur="2px">
      <ValidationObserver v-slot="{ invalid }">

        <div class="card-body">
          <div class="mb-15">
            <h6 class="text-danger">*نکته: <span class="text-dark">مهارت های ویژه</span></h6>
            <h6 class="text-danger">*نکته: <span class="text-dark">مهارت های کلی و معمولی</span></h6>
          </div>
          <div class="col-12">
            <div v-for="(object,index) in myarray" v-bind:key="index">
              <b-row class="form-group mt-10">
                <b-col md="4">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      نام مهارت
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required|min:3" v-slot="{ errors }">
                        <input
                            type="text"
                            class="form-control"
                            placeholder="مثلا : توسعه دهنده php "
                            v-model="object.name"
                            name=" نام مهارت"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>


                <b-col md="4">
                  <div class="form-group">
                    <label class="col-form-label text-lg-right text-left">
                      توضیحات
                      <span class="text-danger">*</span>
                    </label>
                    <div class="custom-file">
                      <ValidationProvider rules="required|min:3" v-slot="{ errors }">

                        <input
                            type="text"
                            class="form-control"
                            placeholder="توضیح مختصر در مورد فعالیت های شاخص این مهارت "
                            v-model="object.description"
                            name="توضیحات"
                        />
                        <span class="text-danger">{{ errors[0] }}</span>
                      </ValidationProvider>
                    </div>
                  </div>
                </b-col>

                <b-col md="2" class="mt-6">

                  <label class="col-form-label  text-lg-right text-left">
                    میزان تسط
                    <span :class="object.ability <50 ? 'text-danger' :'text-success'">{{ object.ability }} </span>
                    درصد
                  </label>
                  <veeno
                      v-model="object.ability"
                      :handles="50000000000"
                      :range="{ 'min': 0, 'max': 100 }"
                  >
                  </veeno>
                </b-col>

                <b-col md="2" class="mt-10">
                  <b-button @click="deleteItem(index)">حذف</b-button>
                </b-col>

              </b-row>
              <div class="separator separator-solid separator-border-2 separator-success my-8"></div>
            </div>
          </div>
          <button type="button" class="btn btn-primary col-3" @click="additem">
            افزودن مهارت های ویژه
          </button>

          <div v-if="myarray.length<1" class="col-md-12 mx-auto my-10">
            <div class="alert alert-custom alert-notice alert-light-info fade show" role="alert">
              <div class="alert-icon">
                <i class="flaticon-medal"></i>
              </div>
              <div class="alert-text text-black-50 mx-4">
                <b>مهارت های ویژه |</b> هیچ اطلاعاتی ثبت نشده است، برای ثبت اطلاعات بر روی "افزودن مهارت های ویژه" کلیک کنید.
              </div>
            </div>
          </div>

          <div class="col-md-12 my-20">
            <button type="button" class="btn btn-secondary col-3">
              افزودن مهارت های کلی
            </button>
            <multiselect
                v-model="generalSkills"
                tagPlaceholder="برای ثبت کلیک کنید"
                deselectLabel="برای حذف کلیک کنید"
                placeholder="اضافه کردن مهارت"
                tag-placeholder="اضافه کردن این مهارت"
                label="name" track-by="name"
                :options="[]"
                :multiple="true"
                :taggable="true"
                @tag="addTag">
            </multiselect>

          </div>
          <div class="col-md-12 mt-20">
            <div class="d-flex flex-column text-md-center">
        <span id="disabled-wrapper" tabindex="-5">
          <button
              v-if="invalid || overlayAccess"
              type="button"
              :disabled="true"
              class="btn btn-success btn-lg btn-block"
          >ذخیره اطلاعات</button>
          <button
              v-else
              @click="addSkills()"
              type="button"
              class="btn btn-success btn-lg btn-block"
          >ذخیره اطلاعات</button>
        </span>
              <b-tooltip
                  v-if="invalid"
                  class="font-family: IRANYekan !important"
                  target="disabled-wrapper"
              >تا زمانی که همه ی فیلد ها تکمیل نشوند این دکمه فعال نمی شود
              </b-tooltip>
            </div>
          </div>
        </div>

      </ValidationObserver>
    </b-overlay>
  </b-overlay>
</template>
<script>
import Multiselect from "vue-multiselect";
import {ValidationObserver, ValidationProvider} from "vee-validate";
import veeno from "veeno";
import "nouislider/distribute/nouislider.min.css";
import gql from "graphql-tag";
import addSkills from "~/apollo/mutation/resume/addSkills.gql";

export default {
  props: ['option'],
  name: "addSkills",
  components: {
    Multiselect,
    veeno,
    ValidationObserver,
    ValidationProvider,
  },
  data() {
    return {
      myarray: [],
      generalSkills: [],
      errors: null,
      overlay: false,
      overlayAccess: false,
    };
  },

  async mounted() {
    if (this.option){
      if (this.option.ConfirmationStatus!=="Filling"){
        this.overlayAccess=true;
      }
      if (this.option.skills){
        this.setValue()
      }
    }
  },

  methods: {
    setValue() {
      let self = this
      this.option.skills.forEach(function (val) {
        if (val.vip == true) {
          self.myarray.push(val)
        } else {
          self.generalSkills.push(val)
        }
      })
    },
    additem() {
      let myObject = {
        name: "",
        ability: "",
        vip: true,
        description: ""
      }
      this.myarray.push(myObject);
    },
    deleteItem(index) {
      Swal.fire({
        title: "حذف مهارت",
        text: "آیا از حذف این مهارت اطمینان دارید؟",
        icon: "warning",
        confirmButtonText: "باشه",
        cancelButtonText: "انصراف",
        showCancelButton: true,
      }).then(res => {
        res.isConfirmed ? this.myarray.splice(index, 1) : '';
      });
    },
    addTag(newTag) {
      const tag = {
        name: newTag,
        ability: 0,
        description: 0,
      }
      // this.options.push(tag)
      this.generalSkills.push(tag)
    },

    async addSkills() {
      this.overlay = true;
      let skils = this.myarray.concat(this.generalSkills)
      let variables = {
        id: this.option.id,
        skills: JSON.stringify(skils),
      };
      let mutation = gql`
        ${addSkills}
      `;
      await this.$apollo
          .mutate({
            mutation,
            variables,
            context: {headers: {"x-token": this.$auth.getToken("local")}}
          })
          .then(({data}) => {
            this.overlay = false;
            Swal.close();
            Swal.fire({
              title: "موفقیت آمیز",
              text: "اطلاعات با موفقیت ثبت شد.",
              icon: "success",
              confirmButtonText: "باشه"
            }).then((res) => {
              this.$emit('my-event', {step: 'addSkills', info: skils})
            })
          }).catch(err => {
            this.overlay = false;
            Swal.close();
            let gqlError = err.graphQLErrors;
            if (gqlError.length > 0) {
              if (err.graphQLErrors[0].extensions.code == "UNAUTHENTICATED") {
                let self = this;
                console.log('please login')
                /* this.$auth.logout().then(res => {
                   self.$router.push("/login");
                 });*/
              }
            } else {
              Swal.fire({
                title: "خطا",
                text:
                    "مشکل در ارتباط، لطفا اتصال اینترنت خود را بررسی و سپس مجددا تلاش کنید",
                icon: "error",
                confirmButtonText: "باشه"
              });
            }
          });
    },


  }
}
</script>
<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>

<style>
.multiselect__option:after {
  top: 0;
  left: 0 !important;
  position: absolute;
  line-height: 40px;
  padding-right: 12px;
  padding-left: 20px;
  font-size: 13px;
}

.multiselect__option:after {
  right: auto !important;
  left: 0 !important;
}
</style>